package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.TotalFreedomMod;
import me.totalfreedom.totalfreedommod.command.handling.*;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.luckperms.api.track.PromotionResult;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@Intercept("op")
@CommandPermissions(permission = "op", source = SourceType.BOTH, cooldown = 5)
@CommandParameters(description = "op a player", usage = "/<command> <partialname>")
public class Command_op extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length < 1)
        {
            return false;
        }

        boolean silent = false;
        if (args.length == 2)
        {
            silent = args[1].equalsIgnoreCase("-s");
        }

        Player player = Bukkit.getServer().getPlayer(args[0]);

        if (player == null || plugin.al.isVanished(player.getUniqueId()))
        {
            msg(sender, PLAYER_NOT_FOUND);
            return true;
        }

        boolean b = silent;
        PromotionResult result = TotalFreedomMod.getPlugin().getHierarchy()
                .promoteUser(TotalFreedomMod.getPlugin().getHierarchy().op(), player);

        if (!result.wasSuccessful())
        {
            msgNew("<red><player> is already op!", player(player));
            return true;
        }

        msg(player, YOU_ARE_OP);

        if (!b)
        {
            FUtil.adminAction(sender.getName(), "Opping " + player.getName(), false);
        }


        return true;
    }
}