package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.TotalFreedomMod;
import me.totalfreedom.totalfreedommod.command.handling.CommandParameters;
import me.totalfreedom.totalfreedommod.command.handling.CommandPermissions;
import me.totalfreedom.totalfreedommod.command.handling.FreedomCommand;
import me.totalfreedom.totalfreedommod.command.handling.SourceType;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.luckperms.api.track.PromotionResult;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

@CommandPermissions(permission = "op.all", source = SourceType.BOTH, cooldown = 30)
@CommandParameters(description = "op everyone on the server.", usage = "/<command>")
public class Command_opall extends FreedomCommand
{
    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        FUtil.adminAction(sender.getName(), "Opping all players on the server", true);

        server.getOnlinePlayers().forEach(player ->
        {
            PromotionResult result = TotalFreedomMod.getPlugin().getHierarchy()
                    .promoteUser(TotalFreedomMod.getPlugin().getHierarchy().op(), player);

            if (!result.wasSuccessful())
            {
                msgNew("<red>Player is already op!", player(player));
                return;
            }

            msg(player, YOU_ARE_OP);
        });

        return true;
    }
}